# -*- coding: utf-8 -*-

"""
    greenbyteapi

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from greenbyteapi.api_helper import APIHelper

class HseIncidentsResponse(object):

    """Implementation of the 'Hse Incidents Response' model.

    An HSE incident.

    Attributes:
        hse_incident_id (int): The id of an HSE incident.
        site_id (int): The id of a site.
        device_id (int): The id of a device.
        timestamp (datetime): The timestamp when the incident occurred. The
            timestamp is in the time zone configured in the Greenbyte Platform
            without UTC offset.
        hse_category (HSECategoryEnum): The category of an HSE incident.
        lost_time_injury (bool): Whether or not the incident resulted in an
            injury sustained on the job, causing loss of productive work
            time.
        incident_description (string): The description related to the
            incident.
        resolved (bool): Whether or not the incident has been resolved.
        resolved_timestamp (datetime): The timestamp when the incident has
            been resolved.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "hse_incident_id":'hseIncidentId',
        "site_id":'siteId',
        "device_id":'deviceId',
        "timestamp":'timestamp',
        "hse_category":'hseCategory',
        "lost_time_injury":'lostTimeInjury',
        "incident_description":'incidentDescription',
        "resolved":'resolved',
        "resolved_timestamp":'resolvedTimestamp'
    }

    def __init__(self,
                 hse_incident_id=None,
                 site_id=None,
                 device_id=None,
                 timestamp=None,
                 hse_category=None,
                 lost_time_injury=False,
                 incident_description=None,
                 resolved=False,
                 resolved_timestamp=None):
        """Constructor for the HseIncidentsResponse class"""

        # Initialize members of the class
        self.hse_incident_id = hse_incident_id
        self.site_id = site_id
        self.device_id = device_id
        self.timestamp = APIHelper.RFC3339DateTime(timestamp) if timestamp else None
        self.hse_category = hse_category
        self.lost_time_injury = lost_time_injury
        self.incident_description = incident_description
        self.resolved = resolved
        self.resolved_timestamp = APIHelper.RFC3339DateTime(resolved_timestamp) if resolved_timestamp else None


    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        hse_incident_id = dictionary.get('hseIncidentId')
        site_id = dictionary.get('siteId')
        device_id = dictionary.get('deviceId')
        timestamp = APIHelper.RFC3339DateTime.from_value(dictionary.get("timestamp")).datetime if dictionary.get("timestamp") else None
        hse_category = dictionary.get('hseCategory')
        lost_time_injury = dictionary.get("lostTimeInjury") if dictionary.get("lostTimeInjury") else False
        incident_description = dictionary.get('incidentDescription')
        resolved = dictionary.get("resolved") if dictionary.get("resolved") else False
        resolved_timestamp = APIHelper.RFC3339DateTime.from_value(dictionary.get("resolvedTimestamp")).datetime if dictionary.get("resolvedTimestamp") else None

        # Return an object of this model
        return cls(hse_incident_id,
                   site_id,
                   device_id,
                   timestamp,
                   hse_category,
                   lost_time_injury,
                   incident_description,
                   resolved,
                   resolved_timestamp)


